/***** in file cbess.c *****/
DllPort fcomplex SphBesselJ( int n, fcomplex x);
DllPort fcomplex DSphBesselJ( int l, fcomplex x );
DllPort fcomplex SphBesselH( int l, fcomplex x );
DllPort fcomplex DSphBesselH( int l, fcomplex x );
DllPort dcomplex CBessJ( int n, dcomplex z);
DllPort dcomplex CBessI( int n, dcomplex z);
DllPort dcomplex CDBessI( int n, dcomplex z );
DllPort dcomplex CBessK( int n, dcomplex z );
DllPort dcomplex CDBessK( int n, dcomplex z );


/****** in file complex.c ********/
DllPort fcomplex Complex(float re, float im);
DllPort fcomplex Csub(fcomplex a, fcomplex b);
DllPort float Cphas(fcomplex z);
DllPort float Cabs(fcomplex z);
DllPort fcomplex Csqrt(fcomplex z);
DllPort fcomplex RCmul(float x, fcomplex a);
DllPort fcomplex Cexp(fcomplex z);
DllPort fcomplex Cmul(fcomplex a, fcomplex b);
DllPort fcomplex Cdiv(fcomplex a, fcomplex b);
DllPort fcomplex Clog(fcomplex z);
DllPort fcomplex Cadd(fcomplex a, fcomplex b);
DllPort fcomplex Cpolar(float abs, float phase);
fcomplex Conjg(fcomplex z);
DllPort fcomplex ICmul( float y, fcomplex a );
DllPort fcomplex SphHarmonic( int l, float theta );
fcomplex Ccos( fcomplex x );
fcomplex Csin( fcomplex x );


/****** in file dcomplex.c ********/
DllPort dcomplex dCadd(dcomplex a, dcomplex b);
DllPort dcomplex dCsub(dcomplex a, dcomplex b);
DllPort dcomplex dCmul(dcomplex a, dcomplex b);
DllPort dcomplex dComplex(double re, double im);
dcomplex dConjg(dcomplex z);
DllPort dcomplex dCdiv(dcomplex a, dcomplex b);
DllPort double   dCabs(dcomplex z);
DllPort dcomplex dCsqrt(dcomplex z);
DllPort dcomplex dRCmul(double x, dcomplex a);
double   dCphas(dcomplex z);
dcomplex dCpolar(double abs, double phase);
DllPort dcomplex dICmul( double y, dcomplex a );
DllPort dcomplex dCexp( dcomplex x );
dcomplex dSphHarmonic( int l, double theta );
DllPort dcomplex dCcos( dcomplex x );
DllPort dcomplex dCsin( dcomplex x );
dcomplex dClog( dcomplex x );


/****** in file ncorrection.c ********/
DllPort void rcoeff(float n_in, float n_out, float *Rj, float *Rphi);
DllPort float zvalue(PlanarBnds bnd, SDGstruct *SDG);


/****** in file ran.c ********/
DllPort float ran3(int *idum);


/***** in file util_exact.c *****/
DllPort void Calculate_Finc( fcomplex img, Source s, Detector d, float amp_o, fcomplex k, 
		    fcomplex *finc, Fstruct *gradf, PlanarBnds *LastPlane, SDGstruct *SDG );
Fstruct GradInc( fcomplex k, float x, float y, float z );
fcomplex Inc( fcomplex k, float r );
DllPort void ReflectSource( PlanarBnds bnd, Source *s, SDGstruct *SDG );
DllPort void ExtendSource( PlanarBnds bnd, Source *s, SDGstruct *SDG );
DllPort void UnextendSource( PlanarBnds bnd, Source *s, SDGstruct *SDG );


/***** in file util_math.c *****/
DllPort float ix2x(int ix, SDGstruct *SDG);
DllPort int x2ix(float x, SDGstruct *SDG);
DllPort float iy2y(int iy, SDGstruct *SDG);
DllPort int y2iy(float y, SDGstruct *SDG);
DllPort float iz2z(int iz, SDGstruct *SDG);
DllPort int z2iz(float z, SDGstruct *SDG);
DllPort float  Abs3Df( Vector a_v );
DllPort void   Add3Df( Vector *c_v, Vector a_v, Vector b_v );
DllPort void   Sub3Df( Vector *c_v, Vector a_v, Vector b_v );
float  Dist3Df( Vector a, Vector b );
DllPort void   Mult3Df( Vector *c_v, float a, Vector b_v );
DllPort float  DotProd3Df( Vector a_v, Vector b_v );
DllPort float  Max( float a, float b );
DllPort float  Min( float a, float b );
DllPort float  length( float x, float y, float z );
int    Maxi( int a, int b);
int    Mini( int a, int b);


/****** in file util_str.c ********/
DllPort char *Strdup(char *s);
DllPort int Strcasecmp(char *c, char *s);
DllPort void Error(int mode, char *text, SHELLstruct *sh);
DllPort void OnScreen( char *text );
DllPort void Report( char *text, SHELLstruct *sh );
DllPort void ToLog( char *text, SHELLstruct *sh );
DllPort void Bell( void );
DllPort void Exit( int exitcode, SHELLstruct *sh );
float stop_clock(int *clock_counter, char *message, SHELLstruct *sh);